local name, addon = ...
local modulname = 'bags'
local events = {}
local modul = {
	['name'] = modulname
}
local playerID
function addon.scanBag(bag)
	local slot = 1
	local itemlist = {}
	local empty = true
	while(slot<=GetContainerNumSlots(bag)) do
		local texture, itemCount, locked, quality, readable, lootable, itemLink, isFiltered = GetContainerItemInfo(bag, slot)
		if(itemLink) then
			local id = addon['getItemId'](itemLink)
			if(id) then
				empty = false
				if(addon['getResult'](id)) then
					addon['setResult'](id,nil)
				end
				itemlist[id] = itemlist[id] or {}
				itemlist[id]['count'] = itemlist[id]['count'] or 0
				itemlist[id]['count'] = itemlist[id]['count'] + itemCount
				addon['getName'](id)
			end
		end
		slot = slot + 1
	end
	return empty and nil or itemlist
end
local function scanAllBags(delayed)
	if(not addon['funcSync'](scanAllBags,delayed)) then return end
	addon['wipeResults']()
	for bag=0,4 do
		modul['db'][playerID][bag] = addon['scanBag'](bag) -- loop all bought bags
	end
	for k,v in pairs(modul['db'][playerID]) do
		if(k<0 or k>4) then
			modul['db'][playerID][k] = nil -- prevent bogus bags
		end
	end
end
local function bagLoop(id,res)
	local dName = modulname.."Count"
	for k,v in pairs(modul['db']) do
		local units = addon['getUnits']()
		if(units[k]) then
			if(units[k]['faction']==units[playerID]['faction']) then
				local unitname = units[k]['name']
				for bag,list in pairs(v) do
					for a,b in pairs(list) do
						if(a == id) then
							res[unitname] = res[unitname] or {
								[dName] = 0
							}
							res[unitname][dName] = res[unitname][dName] or 0
							res[unitname][dName] = res[unitname][dName] + b['count']
						end
					end
				end
			end
		end
	end
	return res
end
function modul.Search(id,res)
	if(not playerID) then
		playerID = addon.getPID()
		if(playerID) then
			modul['db'][playerID] = modul['db'][playerID] or {}
		end
	end
	return playerID and bagLoop(id,res) or res
end
function modul.Output(input,sum,b)
	local desc = modulname..'Count'
	if(b[desc] and b[desc]>0) then
		input[#input+1] = format("Bags %s",b[desc])
		sum = sum + b[desc]					
	end
	return input,sum
end
function events:BAG_UPDATE(event,bag)
	modul['db'][playerID][bag] = addon['scanBag'](bag)
end  
function events:ITEM_UNLOCKED(event,...)
	scanAllBags(nil)
end
function events:BAG_UPDATE_DELAYED(event,...)
	scanAllBags(nil)
end
local function OnEvent(self,event,...)
	if(not playerID) then
		playerID = addon.getPID()
		if(playerID) then
			modul['db'][playerID] = modul['db'][playerID] or {}
		end
	end
	if(playerID and type(events[event])=='function') then
		events[event](self, event, ...)
	end
end
function modul:Enable()
	modul.status = true
	local list = {}
	for event,func in pairs(events) do
		list[#list+1] = event
	end
	modul.frame = addon['RegisterFunc'](list,"OnEvent",OnEvent)
end
function modul:Disable()
	modul.status = false
	for event,func in pairs(events) do
		self.frame:UnregisterEvent(event)
	end
end
addon['inits'][#addon['inits']+1] = function()
	modul.db,modul.status = addon['RegisterModul'](modul, modulname)
	if(modul.status) then
		modul:Enable()
	end
end