local name, addon = ...
local modulname = 'char'
local events = {}
local modul = {
	['name'] = modulname
}
local playerID
local function scanChar()
	local itemlist = {}
	local empty = true
	for i=1,19 do
		local id = GetInventoryItemID("player", i)
		if(id) then
			empty = false
			if(addon['getResult'](id)) then
				addon['setResult'](id,nil)
			end
			itemlist[id] = itemlist[id] or {}
			itemlist[id]['count'] = (itemlist[id]['count'] or 0) + 1
			addon['getName'](id)
		end
	end
	return empty and nil or itemlist
end
local function bagLoop(id,res)
	local dName = modulname.."Count"
	for k,v in pairs(modul['db']) do
		local units = addon['getUnits']()
		if(units[k]) then
			if(units[k]['faction']==units[playerID]['faction']) then
				local unitname = units[k]['name']
				for bag,list in pairs(v) do
					for a,b in pairs(list) do
						if(a == id) then
							res[unitname] = res[unitname] or {
								[dName] = 0
							}
							res[unitname][dName] = (res[unitname][dName] or 0) + b['count']
						end
					end
				end
			end
		end
	end
	return res
end
function modul.Search(id,res)
	if(not playerID) then
		playerID = addon.getPID()
		if(playerID) then
			modul['db'][playerID] = modul['db'][playerID] or {}
		end
	end
	return playerID and bagLoop(id,res) or res
end
function modul.Output(input,sum,b)
	local desc = modulname..'Count'
	if(b[desc] and b[desc]>0) then
		input[#input+1] = format("Equip %s",b[desc])
		sum = sum + b[desc]					
	end
	return input,sum
end
function events:UNIT_INVENTORY_CHANGED(event,...)
	modul['db'][playerID][0] = scanChar(nil)
end
function events:ITEM_UNLOCKED(event,...)
	modul['db'][playerID][0] = scanChar(nil)
end
local function OnEvent(self,event,...)
	if(not playerID) then
		playerID = addon.getPID()
		if(playerID) then
			modul['db'][playerID] = modul['db'][playerID] or {}
		end
	end
	if(playerID and type(events[event])=='function') then
		events[event](self, event, ...)
	end
end
function modul:Enable()
	modul.status = true
	local list = {}
	for event,func in pairs(events) do
		list[#list+1] = event
	end
	modul.frame = addon['RegisterFunc'](list,"OnEvent",OnEvent)
	OnEvent(modul.frame,"UNIT_INVENTORY_CHANGED")
end
function modul:Disable()
	modul.status = false
	for event,func in pairs(events) do
		self.frame:UnregisterEvent(event)
	end
end
addon['inits'][#addon['inits']+1] = function()
	modul.db,modul.status = addon['RegisterModul'](modul, modulname)
	if(modul.status) then
		modul:Enable()
	end
end